<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG,$USER, $COURSE;

// get course id
$id = optional_param('id', null,PARAM_INTEGER);

// login
momo_login_to_course($id);

// get course information
$course = $COURSE;
$category = get_record('course_categories', 'id', $course->category);
//$teacherids = get_record_select('user_teachers', "course = $id", 'userid');
$teachers = array ();
//foreach ($teacherids as $teacherid) {
//    $teachers[$teacherid] = get_record('user', 'id', $teacherid);
//}


 // check if a current section is marked
 if(!empty($course->marker)){
     $current = true;
 }
 else{
     $current = false;
 }

    $sections = true; // indicates that course is divided in sections
    switch ($course->format) {
        case 'topics':
            $strcurrent = momo_get_string('lbl_course_current_topic');
            $strsingular = momo_get_string('lbl_course_topic');
            $strplural = momo_get_string('lbl_course_topics');
            break;
        case 'weeks':
        case 'weekscss':
            $strcurrent = momo_get_string('lbl_course_current_week');
            $strsingular = momo_get_string('lbl_course_week');
            $strplural = momo_get_string('lbl_course_weeks');
            break;
        default:
            $sections = false; // format has no sections
            break;
    }



// add log entry (needed for statistics)
add_to_log($course->id, 'course', 'view', "view.php?id=$course->id", "$course->id");

/// output
?>
<ps t="<?php momo_print_string('hd_course'); p(' ' . $course->shortname);?>" s="false" bo="true" back="<?php echo(momo_get_back_url($COURSE->id))?>" >
<pa id="i">
<?php momo_print_header($course->shortname, 'crs_course');

    // if a current section is defined print link
    if($current){
?>
<menu type="i" url="<?php echo('s'.$course->marker)?>" display="<?php momo_print_icon_path('crs_section')?>" dt="l" w="<?php echo($strcurrent)?>"/>
<?php }
    // if format supports sections print link
    if($sections){
?>
<menu type="i" url="o" display="<?php momo_print_icon_path('crs_section')?>" dt="l" word="<?php echo($strplural)?>"/>
<?php }
    else { // if there are no sections print plain list
    ?>
<menu type="i" url="a" display="<?php momo_print_icon_path('crs_activity')?>" displayType="l" word="<?php momo_print_string('hd_course_activities')?>"/>
<?php } ?>
<menu type="i" url="d" display="<?php momo_print_icon_path('info')?>" displayType="l" word="<?php momo_print_string('hd_course_details')?>"/>
<?php // print content of section 0 on this page
    $links = momo_get_activity_links($course->id,'0');
    $wrap = $CFG->momo_wrap_limit;
       $count = 1;
               foreach ($links as $link) {
            if ($count > $wrap) { // wrap content
                $count = 1;
                momo_print_paging();
            }

            // print the link
            echo ($link);
            // increment counter
            $count++;
        }
?>
</pa>



<?php    // print sections overview
    if($sections){
        // define course format
        $sectionlist = get_records('course_sections','course',$course->id,'section ASC');
         ?>
<pa id="o">
<?php // print sections
        $wrap = $CFG->momo_wrap_limit;
        $count = 0;
        foreach ($sectionlist as $section) {
            // do not show section 0, unused sections or invisible sections
            if($section->section == 0 || $section->section > $course->numsections || empty($section->visible))continue;

            if ($count > $wrap) { // wrap content
                $count = 1;
                momo_print_paging();
            }
            // print section link
            if(!empty($section->visible)){
                // if we have no summary print "week/topic" + number
                if(empty($section->summary)){
                    $caption = $strsingular . ' ' . $section->section;
                }
                else{
                    $caption = momo_get_converted_text($section->summary);
                }
            ?>
<menu type="i" url="<?php echo('s'.$section->section)?>" dt="l" di="<?php momo_print_icon_path('crs_section')?>" w="<?php p(momo_truncate($caption))?>" />
<?php
            }
            // increment counter
            $count++;
        }
?>
<back type="i" url="i" />
</pa>

<?php // then print activities page for each section

        $wrap = $CFG->momo_wrap_limit;
        $count = 1;
        foreach ($sectionlist as $section){
                // do not show section 0 or invisible sections
                if($section->section == 0 || empty($section->visible))continue;
                // if we have no summary print "week/topic" + number
                if(empty($section->summary)){
                    $caption = $strsingular . ' ' . $section->section;
                }
                else{
                    $caption = momo_get_converted_text($section->summary);
                }

                // get activities in this section
                $links = momo_get_activity_links($course->id,$section->section);

?>

<pa id="<?php echo('s'.$section->section)?>">
<?php
    momo_print_header($caption, 'crs_activity');

    // print section summary if necessary
    if(strlen($caption) > 20){
        momo_print_converted_text($caption);
        echo('<br/><hr/>');
    }
    if (count($links) < 1) {
        momo_print_notice(momo_get_string('msg_course_no_activities'));
    } else { // print the links
        // counter for paging
        $wrap = $CFG->momo_wrap_limit;
        $count = 1;
        foreach ($links as $link) {
            if ($count > $wrap) { // wrap content
                $count = 1;
                momo_print_paging();
            }

            // print the link
            echo ($link);
            // increment counter
            $count++;
        }
    } // end else
?>
<back type="i" url="o" />
</pa>
<?php } ?>
<?php }
    else{ // provide plain list of all activities
        /// get supported activities
        $links = momo_get_activity_links($course->id);
?>
<pa id="a">
<?php momo_print_header(momo_get_string('hd_course_activities'), 'crs_activity') ?>
<?php
    if (count($links) < 1) {
        momo_print_notice(momo_get_string('msg_course_no_activities'));
    }
    else { // print the links
        // counter for paging
        $wrap = $CFG->momo_wrap_limit;
        $count = 1;
        foreach ($links as $link) {
            if ($count > $wrap) { // wrap content
                $count = 1;
                momo_print_paging();
            }
            // print the link
            echo ($link);
            // increment counter
            $count++;
        }
    } // end else
?>
<back type="i" url="i" />
</pa>
<?php } ?>

<pa id="d">
<?php momo_print_header(momo_get_string('hd_course_details'), 'info') ?>
<font class="h3"/><?php momo_print_string('lbl_course_shortname')?><br/>
<font class="std"/><?php p($course->shortname)?><br/>
<font class="h3"/><?php momo_print_string('lbl_course_fullname')?><br/>
<font class="std"/><?php p($course->fullname)?><br/>
<font class="h3"/><?php momo_print_string('lbl_course_category')?><br/>
<font class="std"/><?php p($category->name)?><br/>
<font class="h3"/><?php momo_print_string('lbl_course_format')?><br/>
<font class="std"/><?php p($course->format)?><br/>
<font class="h3"/><?php momo_print_string('lbl_course_summary')?><br/>
<font class="std"/><?php momo_print_converted_text($course->summary)?><br/>
<font class="h3"/><?php p($course->teacher)?><br/>
<font class="std"/>
<?php
    foreach ($teachers as $teacher) {
?>
<link type="<?php echo($CFG->momo_mle_server_link)?>" url="contact.php&amp;id=<?php echo($teacher->id)?>" dt="l" di="<?php momo_print_icon_path('contact')?>" /> <?php p(momo_truncate($teacher->firstname . ' ' . $teacher->lastname)) ?><br/>
<?php } ?>
<back type="i" url="i" />
</pa>

</ps>