<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG, $USER, $COURSE;
require_once ($CFG->dirroot . '/mod/forum/lib.php'); // forum support

// get id of posting
$id = optional_param('id',0,PARAM_INT);
$action = optional_param('action',null,PARAM_ACTION); // edit, delete

if(!$post = forum_get_post_full($id)){
    momo_print_error('error_parameter');
}
$discussion = get_record('forum_discussions','id',$post->discussion);
$forum = get_record('forum', 'id', $discussion->forum);

/// handle authentication
momo_login_to_course($forum->course);

// check some post parameters (taken from mod/forum/lib)
    $mypost = ($USER->id == $post->userid) ? true : false;
    $age = time() - $post->created;
    $adminedit = (isadmin() and !empty($CFG->admineditalways));
      /// Hack for allow to edit news posts those are not displayed yet until they are displayed
    if (!$post->parent
        && $forumtype == 'news'
        && get_field_sql("SELECT id FROM {$CFG->prefix}forum_discussions WHERE id = $post->discussion AND timestart > ".time())) {
        $age = 0;
    }

$editing = false;
if(!empty($action)){
    switch ($action) {
        case 'delete':
            // delete the given post
            if (!$cm = get_coursemodule_from_instance('forum', $forum->id, $forum->course)) { // For the logs
                    $cm->id = 0;
                }
                if (! $post->parent) {  // post is a discussion topic as well, so delete discussion
                    if ($forum->type == "single") {
                    momo_print_error(momo_get_string('msg_forum_delete_failed'),"forum/forum_discussion.php&amp;id=$discussion->id",$CFG->momo_mle_server_link);
                    }
                    else{
                    forum_delete_discussion($discussion);
                    add_to_log($discussion->course, "forum", "delete discussion",
                               "view.php?id=$cm->id", "$forum->id", $cm->id);
                    // print feedback screen
                    momo_print_success(momo_get_string('msg_forum_discussion_deleted'),"forum/forum_discussion.php&amp;id=$discussion->id",$CFG->momo_mle_server_link);
                    }
                } else if (forum_delete_post($post, isteacher($course->id))) {
                    add_to_log($discussion->course, "forum", "delete post",
                               "discuss.php?d=$post->discussion", "$post->id", $cm->id);
                    // print feedback screen
                    momo_print_success(momo_get_string('msg_forum_post_deleted'),"forum/forum_discussion.php&amp;id=$discussion->id",$CFG->momo_mle_server_link);
                } else {
                    error("An error occurred while deleting record $post->id");
                }
            break;
        default:
            break;
    }
}

/// check for attachment
    $attachment = false;
    if(!empty($post->attachment)){
        $attachment = true;
        // get url to file
        $filearea = forum_file_area_name($post);
        if ($CFG->slasharguments) {
             $ffurl = $CFG->wwwroot . '/file.php' . '/' . $forum->course . $filearea . '/' .$post->attachment;
         }
         else {
             $ffurl = $CFG->wwwroot. '/file.php?file=' . '/' .$forum->course .$filearea . '/' .$post->attachment;
         }
         // create also a specific MOMO compatible file request
         $internalurl = momo_get_binary_file_url($forum->course . $filearea . '/' .$post->attachment);

        /// check type using regex
        $type = strtolower(mimeinfo('type',$post->attachment));
        $imagepattern = '/\.(jpg|jpeg|jpe|png)$/';
        $audiopattern = '/^audio/';
        $videopattern = '/^video/';
        // check if we have an image (only png and jpg are supported)
        if (preg_match($imagepattern, strtolower($post->attachment))) {
            $link = '<image type="r" url="' . $internalurl . '">';
        }
        // check if we have audio 'audio/'
        else if (preg_match($audiopattern, $type)) {
            $link = '<audio location="' . $CFG->momo_mle_server_link . '" contenttype="' . $type . '" url="' . $internalurl . '">';
        }
        // check if we have video 'video/'
        else if (preg_match($videopattern, $type)) {
            $link = '<video location="' . $CFG->momo_mle_server_link . '" contenttype="' . $type . '" url="' . $internalurl . '">';
        }
        // if none of the above matches, the file can not be processed internally. give browser link (including login information)
        else{
            $link = '<link type="p" dt="l" di="' . momo_print_icon_path('internet') . '" url="' . momo_encode_login_information($ffurl) . '">';
        }
}


// response
?>
<ps t="<?php momo_print_string('hd_forum_post')?>" s="false" bo="true" back="<?php echo(momo_get_back_url($COURSE->id))?>">
<pa>
<font class="h1"/>
<image type="l" url="<?php momo_print_icon_path('pst_posting')?>" /> <?php echo($post->subject)?>
<font class="std"/><br/><hr/>
<font class="h3"/><?php momo_print_string('lbl_forum_sender')?><br/>
<font class="std"/><?php p($post->firstname . ' ' . $post->lastname)?><br/>
<font style="i"/><?php $date = usergetdate($post->created);
    echo($date['mday'].'.'.$date['mon'].'.'.$date['year'].', '.$date['hours'].':'.$date['minutes']);?><font style="p"/><br/>
<font class="h3"/><?php momo_print_string('lbl_forum_subject')?><br/>
<font class="std"/><?php p($post->subject)?><br/>
<font class="h3"/><?php momo_print_string('lbl_forum_message')?><br/>
<font class="std"/><?php momo_print_converted_text($post->message)?><br align="center"/>
<?php // if post has attachment print appropriate link
    if($attachment){
?>
<hr/>
<font class="h3"/><?php momo_print_string('lbl_forum_attachement')?><font class="std"/><br/>
<?php echo($link)?><br/>
<?php echo(momo_truncate($post->attachment))?><br/>
<?php } ?>
<hr/>
<?php // check if post can be edited
    if ($mypost or $adminedit) {
        if (($age < $CFG->maxeditingtime) or $adminedit) { // edit allowed
?>
<menu type="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum_post_new.php&amp;edit=<?php echo($post->id)?>&amp;discussion=<?php echo($post->discussion)?>" dt="l" di="<?php momo_print_icon_path('edit') ?>" word="<?php momo_print_string('lbl_forum_edit')?>" full="false"/><br/>
<?php }
    }
    // check if post can be deleted
    if (($mypost and $age < $CFG->maxeditingtime) or isteacher($forum->course)) { ?>
<menu type="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum_post.php&amp;id=<?php echo($post->id)?>&amp;action=delete" dt="l" di="<?php momo_print_icon_path('delete')?>" word="<?php momo_print_string('lbl_forum_delete')?>" full="false"/><br/>
<?php } ?>
<?php // check if response is allowed
    if(forum_user_can_post($forum,$USER)){ ?>
<menu type="<?php echo($CFG->momo_mle_server_link)?>" url="forum/forum_post_new.php&amp;discussion=<?php echo($post->discussion)?>&amp;parent=<?php echo($post->id)?>" dt="l" di="<?php momo_print_icon_path('pst_posting_new')?>" word="<?php momo_print_string('nav_reply')?>" full="false"/>
<?php } ?>
</pa>
</ps>