<?php
/* (c) 2007, Andreas Forstinger, www.mobilemoodle.org */
global $CFG;
require_once ($CFG->dirroot . '/message/lib.php'); // messaging support

// get type
$type = optional_param('type',null,PARAM_ALPHA);

if($type == 'search'){ // query archive by search
    // get search query
    $query = optional_param('query',null,PARAM_RAW);
    // get search scope
    $in = optional_param('in',null,PARAM_RAW);
    $out = optional_param('out',null,PARAM_RAW);
    // if no query yet show search form
    $newsearch = false;
    if($query == null){
        $newsearch = true;
    }
     else {
        // search messages by keyword
        $query = clean_text(trim($query));
        $keywords = explode(' ', $query);
        $in = $out = false;
        if(!empty($in)) $in = true;
        if(!empty($out)) $out = true;
        // query database for messages
        $results = message_search($keywords,$out,$in);
        // get sender information
        foreach($results as $message) {
              $message->sender = get_record('user', 'id', $message->useridfrom);
         }
    }
}
else{ // query archive by sender
    $query = optional_param('query',null,PARAM_RAW);
    $newsearch = false;
    if($query == null){
        $newsearch = true;
    }
    else{

    }
}
// print response
?>
<ps t="<?php momo_print_string('hd_msg_archive')?>" s="false" bo="true" back="msg/messages.php">
<pa>
<?php momo_print_header(momo_get_string('hd_msg_archive'), 'msg_archive') ?>

<?php
    if(empty($type)){ // no type has been selected, show main selection
?>
<menu type="<?php echo($CFG->momo_mle_server_link)?>" url="msg/message_archive.php&amp;type=search" dt="l" di="<?php momo_print_icon_path('search')?>" word="<?php momo_print_string('lbl_msg_archive_search')?>" />
<?php
    }
    else if($type == 'search'){ // type search ?
        if($newsearch){ // show search form ?>
<image type="l" url="<?php momo_print_icon_path('info')?>" /> <?php momo_print_string('msg_search_msg_hint') ?><br/>
<textbox id="query" size="20"/>
<?php momo_print_string('lbl_msg_archive_search_scope')?><br/>
<checkbox id="in"> <?php momo_print_string('lbl_msg_archive_search_in')?><br/>
<checkbox id="out"> <?php momo_print_string('lbl_msg_archive_search_out')?><br/>
<button type="u" action="msg/message_archive.php&amp;type=search" data="00" dt="l" di="<?php momo_print_icon_path('search')?>"> <?php momo_print_string('nav_search') ?><br/>
<?php
    }
    else { // show search results
        if(empty($results)){ // no results
            momo_print_notice(momo_get_string('msg_search_no_results'));
           }
        else { // there are results, print list
            // counter for paging
            $wrap = $CFG->momo_wrap_limit;
            $count = 1;
            foreach($results as $result){
                if($count > $wrap){ // wrap content
                    $count = 1;
                    momo_print_paging();
                }?>
<link type="<?php echo($CFG->momo_mle_server_link)?>" url="msg/message.php&amp;msg=<?php echo($result->id)?>&amp;read=1" dt="l" di="<?php momo_print_icon_path('msg_read')?>"> <?php p(momo_truncate($result->sender->firstname . ' ' . $result->sender->lastname)) ?><br/>
<font style="i"/>
<?php $date = usergetdate($result->timecreated);
   echo(' ('.$date['mday'].'.'.$date['mon'].'.'.$date['year'].','.$date['hours'].':'.$date['minutes'].') '.'<br/>');
?><font style="p"/>
<?php $count++;
            }
        }
    }
} // end type search
else { // query by sender
        if($newsearch){ // show search form ?>
<?php momo_print_string('lbl_msg_recipient') ?><br/>
<textbox id="query" size="20"/>
<button type="u" action="msg/message_archive.php&amp;type=sender" data="00" dt="l" di="<?php momo_print_icon_path('search')?>"> <?php momo_print_string('nav_search') ?><br/>
<image type="ml" url="<?php momo_print_icon_path('info')?>"/> <?php momo_print_string('msg_search_user_hint') ?><br/>
<?php            }
    else { // show search results
        if(empty($results)){ // no results
            momo_print_notice(momo_get_string('msg_search_no_results'));
           }
        else { // there are results, print list
            // counter for paging
            $wrap = $CFG->momo_wrap_limit;
            $count = 1;
            foreach($results as $result){
                if($count > $wrap){ // wrap content
                    $count = 1;
                    momo_print_paging();
                }?>
<link type="<?php echo($CFG->momo_mle_server_link)?>" url="msg/message.php&amp;msg=<?php echo($result->id)?>&amp;read=1" dt="l" di="<?php momo_print_icon_path('msg_read')?>"> <?php p(momo_truncate($result->sender->firstname . ' ' . $result->sender->lastname)) ?><br/>
<font style="i"/>
<?php $date = usergetdate($result->timecreated);
   echo(' ('.$date['mday'].'.'.$date['mon'].'.'.$date['year'].','.$date['hours'].':'.$date['minutes'].') '.'<br/>');
?><font style="p"/>
<?php $count++;
            }
        }
    }
}
?>
</page>
</pagesuite>